
rRect = function(mc, tl_x, tl_y, br_x, br_y, roundness){

 var r = Math.min(br_x - tl_x , br_y - tl_y) * roundness / 200;

 var ex = r; var ey = 0;

 mc.moveTo(br_x, tl_y + r);

 for (var a = 45; a < 405; a += 45) {

  if (a % 90){

   var x = a > 90 && a < 270 ? tl_x + r : br_x - r;

   var y = a > 180 ? tl_y + r : br_y - r;

   mc.curveTo(ex + x, ey + y, ex + x, ey + y);

  }

  ex = r * Math.cos(a / 57.296);

  ey = r * Math.sin(a / 57.296);

  var cx = ex + r * .41421 * Math.sin(a / 57.296);

  var cy = ey - r * .41421 * Math.cos(a / 57.296);

  mc.curveTo(cx + x, cy + y, ex + x, ey + y);

 }

}



ip = Math.min(is_padding,Math.min(os_width,os_height)/2); // inner padding

hw = os_width /2; // half width

hh = os_height /2; // half height

r = 1.5 * Math.sqrt(hw * hw + hh * hh);



p = createEmptyMovieClip('p_mc',l); // preloader mc

p.createEmptyMovieClip('os',1); // outer shape mc

p.createEmptyMovieClip('is',2); // inner shape mc

p.createEmptyMovieClip('m',3); // mask mc

p.createTextField('l',4,0,0,0,0);

p.is.setMask(p.m);

p.l.setNewTextFormat(text_format);

p.l.selectable = false;

p.l.autoSize = 'center';

p._x = Stage.width / 2 + dx;

p._y = Stage.height / 2 + dy;



p.os.lineStyle(line_thickness,os_line_color,os_line_alpha);

p.os.beginGradientFill(os_fill_type < 2 ? 'linear' : 'radial',os_fill_colors,os_fill_alphas,os_fill_ratios,{matrixType:'box',x:-hw,y:-hh,w:2*hw,h:2*hh,r:os_fill_type ? -Math.PI/2 : 0});

rRect(p.os,-hw,-hh,hw,hh,os_roundness);

p.os.endFill();

p.os.lineStyle(line_thickness,is_line_color,is_line_alpha);

rRect(p.os,ip - hw,ip - hh,hw - ip,hh - ip,is_roundness);



p.is.lineStyle(line_thickness,is_line_color,is_line_alpha);

p.is.beginGradientFill(is_fill_type < 2 ? 'linear' : 'radial',is_fill_colors,is_fill_alphas,is_fill_ratios,{matrixType:'box',x:ip-hw,y:ip-hh,w:2*(hw-ip),h:2*(hh-ip),r:is_fill_type ? -Math.PI/2 : 0});

rRect(p.is,ip - hw,ip - hh,hw - ip,hh - ip,is_roundness);

p.is.endFill();



onEnterFrame = function(){

 p._visible = getTimer() > delay_showing;

 perc = getBytesLoaded() / getBytesTotal();

 if (perc < 1){



  p.m.clear();

  p.m.lineStyle(line_thickness,0);

  p.m.beginFill(0);

  if (progress_type == 0){

   rRect(p.m,ip - hw,ip - hh, ip - hw + 2*(hw-ip)*perc, hh - ip,0);

  } else if (progress_type == 1){

   rRect(p.m,ip - hw,ip - hh + 2*(hh-ip)*(1-perc), hw - ip, hh - ip,0);

  } else {

   p.m.moveTo(0,0);

   for (var a = 0; a <= 360; a += 45) {

    var a0 = Math.min(a,perc*360) / 57.296;

    p.m.lineTo(r * Math.sin(a0),-r * Math.cos(a0));

   }

  }

  p.m.endFill();

  if (display) p.l.text = display > 1 ? Math.floor(getBytesLoaded() / 1024) + ' KB' : Math.floor(100 * perc) + ' %';

  p.l._y = (text_align - 1) * (hh + p.l.textHeight) - p.l.textHeight / 2 - 2;



 } else {

  onEnterFrame = null;

  p.removeMovieClip();

  gotoAndPlay(3);

 }

}



onEnterFrame();




